
.definelabel CurrSpriteData,0x3000738
.definelabel SpriteRNG,0x300083C
.definelabel SamusData,0x30013D4

.definelabel PlaySound,0x8002B20
.definelabel CheckSlope,0x800F594
.definelabel CheckBlock,0x800F720
.definelabel MoveSprite,0x800F978
.definelabel CheckSpriteAnimationEnd,0x800FBC8
.definelabel FrozenRoutine,0x800FFE8
.definelabel SpriteDead,0x8011084
.definelabel StunCheck,0x8011280
.definelabel PrimarySpriteStats,0x82B0D68

.org 0x804B604						;pirate AI
	push    r4,r14
	add		sp,-4h
	ldr     r4,=CurrSpriteData 
	bl		StunCheck
	cmp		r0,1h
	beq		@@SetRun
	mov     r0,r4                                    
	add     r0,30h                                 
	ldrb    r0,[r0]			;frozen timer                                
	cmp     r0,0h			;checking if frozen                                  
	beq     @@Continue                             
	bl      FrozenRoutine
	b		@@Return
@@Continue:	
	mov     r0,r4                                   
	add     r0,24h                                  
	ldrb    r0,[r0] 		;pose 
	cmp		r0,6h			;true if dead
	bgt		@@Dead
	ldr		r1,=@@Jumptable
	lsl		r0,r0,2h
	add		r0,r1,r0
	ldr		r0,[r0]
	mov		r15,r0
.pool
@@JumpTable:
	.word @@StartAI,@@WalkAI,@@TurnAI
	.word @@TurnAI2,@@SetRunAI,@@RunAI
@@StartAI:
	bl 		Initialize
	b		@@Return
@@WalkAI:
	bl		WalkAI
	b		@@Return
@@TurnAI:
	bl		TurnAI
	b		@@Return
@@TurnAI2:
	bl		Turn2AI
	b		@@Return
@@SetRunAI:
	bl		SetRunAI
	b		@@Return
@@RunAI:
	bl		RunAI
	b		@@Return
@@SetRun:
	mov		r0,r4
	add		r0,2Ch
	mov		r1,0F0h
	strb	r1,[r0]
	sub		r0,8h			;pose

	mov		r1,4h			;start running pose 
	strb	r1,[r0]
	b		@@Return
@@Dead:
	ldr		r0,=16Ah		;pirate die sound
	bl		PlaySound
	mov		r0,0h
	strh	r0,[r4]
	mov		r0,r4                           
	ldrh    r1,[r0,2h]		;sprite Y position                              
	sub     r1,80h                                   
	ldrh    r2,[r0,4h]		;sprite X position                               
	mov     r0,20h                                  
	str     r0,[sp]                                 
	mov     r0,0h                                   
	mov     r3,1h                                   
	bl      SpriteDead
@@Return:
	add		sp,4h
	pop		r4
	pop		r0
	bx		r0
.pool


.org 0x8304054
Initialize:
	ldr     r2,=CurrSpriteData  	
	mov     r1,r2 
	mov		r3,0h
	add     r1,27h                                  
	mov     r0,30h                                  
	strb    r0,[r1]			;27h                                 
	mov     r0,r2                                   
	add     r0,28h                                  
	strb    r3,[r0] 		;28h                                
	add     r1,2h                                   
	mov     r0,20h                                  
	strb    r0,[r1]			;29h 
	strb	r3,[r1,3h]		;timer 
	strb	r3,[r1,5h]		;accel timer
	ldr		r1,=0FF60h                                  
	strh    r1,[r2,0Ah]			;top hitbox                             
	strh    r3,[r2,0Ch]  		;bottom hitbox    	                         
	ldr     r0,=82E4970h		;OAM Pointer                            
	str     r0,[r2,18h]
	strb    r3,[r2,1Ch]                             
	strh    r3,[r2,16h]                             
	mov     r0,r2                                   
	add     r0,25h
	mov		r1,4h
	strb    r1,[r0]			;can hurt Samus                                 
	mov     r1,r2                                   
	add     r1,24h                                  
	mov     r0,1h                                   
	strb    r0,[r1] 		;stores pose 1 
	ldr     r2,=PrimarySpriteStats			                            
	ldrb    r1,[r4,1Dh]                             
	lsl     r0,r1,3h                                
	add     r0,r0,r1                                
	lsl     r0,r0,1h                                
	add     r0,r0,r2                                
	ldrh    r0,[r0]                                 
	strh    r0,[r4,14h]		;stores health     	
	ldr		r0,=SpriteRNG
	ldrb	r0,[r0]
	mov		r1,1h
	and		r0,r1
	cmp		r0,1h
	beq		@@LeftHitbox
	ldrh	r0,[r4]
	mov		r1,90h
	lsl		r1,r1,2h		;240h
	orr		r0,r1
	strh	r0,[r4]			;flips sprite, makes move rightwards
	ldr		r1,=0FFE8h		;hitboxes when moving right
	strh    r1,[r4,0Eh]  
	mov		r1,40h
	strh    r1,[r4,10h]
	b		@@Return
.pool
@@LeftHitbox:
	ldr		r1,=0FFC0h		;hitboxes when moving left
	strh    r1,[r4,0Eh]  
	mov		r1,18h
	strh    r1,[r4,10h]
@@Return:
	bx		r14
.pool

SetRunAI:
	push	r14
	ldr		r1,=SamusData
	ldrh	r1,[r1,12h]		;Samus X
	ldrh	r0,[r4,4h]		;sprite X
	ldrh	r2,[r4]
	mov		r3,40h
	and		r2,r3
	cmp		r2,40h
	beq		@@CheckRight
	cmp		r0,r1
	bgt		@@Turn
	b		@@Run
.pool
@@CheckRight:
	cmp		r0,r1
	blt		@@Turn
@@Run:
	mov		r0,r4
	add		r0,24h
	mov		r1,5h			;run pose
	strb	r1,[r0]
	ldr     r0,=Run_OAM		;OAM Pointer                            
	str     r0,[r4,18h]
	b		@@Return
@@Turn:
	mov		r0,r4
	add		r0,24h
	mov		r1,2h			;turn pose
	strb	r1,[r0]
	ldr     r0,=Turn_OAM		;OAM Pointer                            
	str     r0,[r4,18h]
	mov		r0,0h
	strb	r0,[r4,1Ch]
	strh	r0,[r4,16h]
@@Return:
	ldr		r0,=169h			;pirate hurt sound
	bl		PlaySound
	pop		r0
	bx		r0
.pool
	
WalkAI:
	push	r14
	mov		r0,r4
	add		r0,2Eh
	ldrb	r1,[r0]
	cmp		r1,0Fh
	beq		@@MoveSprite
	add		r1,1h
	strb	r1,[r0]
@@MoveSprite:
	bl		MoveSpriteAI
@@Return:
	pop		r0
	bx		r0
.pool

RunAI:
	push	r14
	mov		r0,r4
	add		r0,2Eh
	ldrb	r1,[r0]
	cmp		r1,20h
	beq		@@MoveSprite
	add		r1,1h
	strb	r1,[r0]
@@MoveSprite:
	bl		MoveSpriteAI
	mov		r0,r4
	add		r0,2Ch				;run timer
	ldrb	r1,[r0]
	cmp		r1,0h
	beq		@@WalkSet
	sub		r1,1h
	strb	r1,[r0]
	b		@@Return
@@WalkSet:
	sub		r0,8h				;pose
	mov		r1,1h				;walk pose
	strb	r1,[r0]
	add		r0,0Ah				;accel timer
	mov		r1,0Fh
	strb	r1,[r0]
	ldr     r0,=82E4970h		;Vanilla Walking OAM                             
	str     r0,[r4,18h]
@@Return:
	pop		r0
	bx		r0
.pool

MoveSpriteAI:
	push	r14
;adjust sprite's Y based on slope, needed here as steep slopes clip in solid blocks slightly. Wall checks messed up othewise		
	bl		CheckSlope
	ldrh	r1,[r4,4h]			;X pos
	ldrh	r0,[r4,2h]			;Y pos
	bl		CheckBlock
	cmp		r0,0h					;checking if sprite is floating
	bne		@@Continue
	ldrh	r0,[r4,2h]				;Y pos
	add		r0,10h
	strh	r0,[r4,2h]				;checks again if on slope, prevents walking off of slope
	bl		CheckSlope
@@Continue:
	ldrh	r0,[r4]					
	mov		r1,40h
	and		r0,r1
	cmp		r0,40h				;checks direction
	beq		@@RightChecks
	ldrh	r1,[r4,4h]			;X pos
	ldrh	r0,[r4,2h]			;Y pos
	bl		CheckBlock			;checking if on steep slope
	cmp		r0,5h
	bgt		@@NoSlope
	cmp		r0,2h
	bge		@@BlockChecks
@@NoSlope:
	ldrh	r1,[r4,4h]			;X pos
	ldrh	r0,[r4,2h]			;Y pos
	sub		r0,1h
	sub		r1,40h				;checks if solid block is blocking path (bottom)
	bl		CheckBlock
	cmp		r0,11h
	beq		@@Turn
	ldrh	r1,[r4,4h]			;X pos
	ldrh	r0,[r4,2h]			;Y pos
	sub		r1,40h				;checking if drop off
	bl		CheckBlock
	cmp		r0,0h
	beq		@@Turn
@@BlockChecks:
	ldrh	r1,[r4,4h]			;X pos
	ldrh	r0,[r4,2h]			;Y pos
	sub		r1,40h
	sub		r0,81h				;checks if solid block is blocking path (top)
	bl		CheckBlock
	cmp		r0,11h
	beq		@@Turn
	ldrh	r1,[r4,4h]			;X pos
	ldrh	r0,[r4,2h]			;Y pos
	sub		r1,40h
	sub		r0,41h				;checks if solid block is blocking path (middle)
	bl		CheckBlock
	cmp		r0,11h
	beq		@@Turn

	b		@@MoveSprite
@@RightChecks:
	ldrh	r1,[r4,4h]			;X pos
	ldrh	r0,[r4,2h]			;Y pos
	bl		CheckBlock			;checking if on slopes
	cmp		r0,5h
	bgt		@@NoSlope2
	cmp		r0,2h
	bge		@@WallChecks
@@NoSlope2:
	ldrh	r1,[r4,4h]			;X pos
	ldrh	r0,[r4,2h]			;Y pos
	sub		r0,1h
	add		r1,40h				;checks if solid block is blocking path (bottom)
	bl		CheckBlock
	cmp		r0,11h
	beq		@@Turn
	ldrh	r1,[r4,4h]			;X pos
	ldrh	r0,[r4,2h]			;Y pos			
	add		r1,40h			;checking if drop off
	bl		CheckBlock
	cmp		r0,0h
	beq		@@Turn
@@WallChecks:
	ldrh	r1,[r4,4h]			;X pos
	ldrh	r0,[r4,2h]			;Y pos
	add		r1,40h
	sub		r0,81h				;checks if solid block is blocking path (top)
	bl		CheckBlock
	ldrb	r0,[r0]
	cmp		r0,11h
	beq		@@Turn
	ldrh	r1,[r4,4h]			;X pos
	ldrh	r0,[r4,2h]			;Y pos
	add		r1,40h
	sub		r0,41h				;checks if solid block is blocking path (middle)
	bl		CheckBlock
	cmp		r0,11h
	beq		@@Turn
@@MoveSprite:
	mov		r0,r4
	add		r0,2Eh
	ldrb	r0,[r0]
	lsr		r0,r0,2h			;accel value
	bl		MoveSprite
	ldrb    r0,[r4,1Ch]  		;animation counter                           
	cmp     r0,1h                                   
	bne     @@Return                            
	ldrh    r1,[r4,16h]   		                        
	mov     r0,3h                                   
	and     r0,r1                                   
	cmp     r0,0h                                   
	bne     @@Return                            
	ldrh    r1,[r4]                                 
	mov     r0,2h                                   
	and     r0,r1                                   
	cmp     r0,0h  			;checks if onscreen                                 
	beq     @@Return                             
	ldr     r0,=165h 		;used to play footstep sound based on animation frame                                 
	bl      PlaySound                  
	b		@@Return
.pool
@@Turn:
	mov		r0,r4
	add		r0,24h
	mov		r1,2h				;turn pose
	strb	r1,[r0]				;remove this an meme things happen
	ldr		r0,=Turn_OAM		;use 2E43C8 as reference 
	str		r0,[r4,18h]
	mov		r0,0h
	strb	r0,[r4,1Ch]
	strh	r0,[r4,16h]
@@Return:
	pop		r0
	bx		r0
.pool

TurnAI:
	push	r14
	bl		CheckSpriteAnimationEnd
	cmp		r0,0h
	beq		@@Return
	mov		r0,r4
	add		r0,24h			;pose
	mov		r1,3h			;second turn pose
	strb	r1,[r0]
	ldr		r0,=Turn2_OAM
	str		r0,[r4,18h]
	mov		r0,0h
	strb	r0,[r4,1Ch]
	strh	r0,[r4,16h]
	ldrh	r0,[r4]
	mov		r1,90h
	lsl		r1,r1,2h			;240h
	eor		r0,r1
	strh	r0,[r4]				;flips sprite
@@Return:
	pop		r0
	bx		r0
	
Turn2AI:
	push	r14
	bl		CheckSpriteAnimationEnd
	cmp		r0,0h
	beq		@@Return
	mov		r0,r4
	add		r0,2Ch				;run timer
	ldrb	r0,[r0]
	cmp		r0,0h
	bne		@@SetRun
	ldr     r0,=82E4970h		;Vanilla walking OAM                            
	str     r0,[r4,18h]
	mov		r0,0h
	strb	r0,[r4,1Ch]
	strh	r0,[r4,16h]
	mov		r0,r4
	add		r0,24h
	mov		r1,1h				;walking pose
	b		@@Store
.pool
@@SetRun:
	ldr     r0,=Run_OAM		;OAM Pointer                            
	str     r0,[r4,18h]
	mov		r0,0h
	strb	r0,[r4,1Ch]
	strh	r0,[r4,16h]
	mov		r0,r4
	add		r0,24h
	mov		r1,5h				;running pose
@@Store:
	strb	r1,[r0]
	ldrh	r0,[r4]
	mov		r1,40h				;checking direction
	and		r0,r1
	cmp		r0,r1
	bne		@@LeftHitbox
	ldr		r1,=0FFE8h		;hitboxes when moving right
	strh    r1,[r4,0Eh]  
	mov		r1,40h
	strh    r1,[r4,10h]
	b		@@Return
.pool
@@LeftHitbox:
	ldr		r1,=0FFC0h		;hitboxes when moving left
	strh    r1,[r4,0Eh]  
	mov		r1,18h
	strh    r1,[r4,10h]
@@Return:
	pop		r0
	bx		r0
.pool	