.definelabel SpriteData,0x030001AC

FrozenRinka:
	push	r14
	ldr		r0,=CurrSpriteData
	add		r0,24h
	ldrb	r0,[r0]
	cmp		r0,9h					;pose when rinka is spawning
	bne		@@Skip
	bl		NewAI					;makes frozen rinkas stay with pirate
@@Skip:
	bl		FrozenRoutine			
	pop		r0
	bx		r0

NewAI:				;r4 has CurrSpriteData
	ldr		r0,=SpriteData
	mov		r1,r4
	add		r1,23h					;Sprite RAM slot
	ldrb	r1,[r1]
	cmp		r0,0h
	beq		@@Return
	sub		r1,1h					;checks previous slot
	mov		r2,38h
	mul		r1,r2
	add		r1,r1,r0				;next slot in sprite ram
	ldrb	r0,[r1,1Dh]				;ID of slot
	cmp		r0,0B6h					;checking if it's Rinka Pirate
	bne		@@Return
	mov		r0,r1
	add		r0,24h
	ldrb	r0,[r0]
	cmp		r0,0h
	beq		@@Return
	cmp		r0,2h					;rinka pirate turn pose
	beq		@@Turning
	cmp		r0,3h					;rinka pirate turn2 pose
	beq		@@Turning
	ldrh	r0,[r1]	
	cmp		r0,0h
	bne		@@NotDead
	strh	r0,[r4]					;kills rinka if pirate is dead
	b		@@Return
@@NotDead:
	ldrh	r2,[r1,16h]
	ldr		r3,=@@YTable
	add		r3,r2,r3
	ldrb	r3,[r3]
	mov		r2,40h					;checking pirate direction
	and		r0,r2
	ldrh	r2,[r1,2h]				;pirate Y
	cmp		r0,40h
	bne		@@Left
	sub		r0,r2,r3
	ldrh	r1,[r1,4h]				;pirate X
	add		r1,5Ch
	b		@@Store
.pool
@@Left:
	sub		r0,r2,r3
	ldrh	r1,[r1,4h]				;pirate X
	sub		r1,5Ch		
	b		@@Store
@@Turning:	
	ldrh	r0,[r1,16h]				;current pirate animation
	mov		r2,r1	
	add		r2,24h
	ldrb	r2,[r2]
	cmp		r2,3h					;change value based on turnin type to manipulate table value grab
	bne		@@Skip
	add		r0,4h
@@Skip:
	ldr		r2,=@@XTable
	add		r0,r0,r2
	mov		r2,0h
	ldsb	r3,[r0,r2]					;x value to place rinka
	ldrh	r0,[r1]
	mov		r2,40h					;checking pirate direction
	and		r0,r2
	ldrh	r2,[r1,4h]				;pirate X
	cmp		r0,40h
	bne		@@Lefty
	mov		r0,r1
	add		r1,r2,r3
	b		@@Y
.pool
@@Lefty:
	mov		r0,r1
	sub		r1,r2,r3
@@Y:
	ldrh	r0,[r0,2h]
	sub		r0,50h
@@Store:
	strh	r0,[r4,2h]				;new posision for rinka, on block pirate carries
	strh	r1,[r4,4h]
	lsr		r0,r0,6h
	lsr		r1,r1,6h
	mov		r2,r4
	add		r2,2Eh	
	strb	r1,[r2]					;X coords of spawn block
	strb	r0,[r2,1h]				;Y coords of spawn block
@@Return:
	mov		r3,r4
	add		r3,2Dh
	bx		r14
	
@@XTable:
	.byte 0x5C,0x20,0xFC,0xD0
	.byte 0x38,0x4C,0x50,0x60
@@YTable:
	.byte 0x94,0x94,0x98,0x98
	.byte 0x90,0x94,0x98,0x94